//
//  CustomTabBarDelegate.swift
//  CarManager
//
//  Created by Holger Hinzberg on 02.06.15.
//  Copyright (c) 2015 Holger Hinzberg. All rights reserved.
//

import UIKit

class CustomTabBarDelegate : NSObject, UITabBarControllerDelegate
{
    func tabBarController(tabBarController: UITabBarController, didSelectViewController viewController: UIViewController)
    {
        /*
        println(__FUNCTION__)
        
        // Indexposition der gewählte Szene ausgeben
        print("Gewählter Szene-Index: ")
        println(tabBarController.selectedIndex)
        
        // Den Hintergrund des Views mit roter Farbe färben
        viewController.view.backgroundColor
        = UIColor.redColor()
        */
        
        UIView.beginAnimations("Switch Tab", context: nil)
        UIView.setAnimationDuration(1.5)
        UIView.setAnimationCurve(UIViewAnimationCurve.EaseIn)
        UIView.setAnimationTransition(UIViewAnimationTransition.FlipFromRight, forView: tabBarController.view, cache: true)
        UIView.commitAnimations()
        
    }
    
    func tabBarController(tabBarController: UITabBarController, shouldSelectViewController viewController: UIViewController) -> Bool
    {
        // Ist der gewählte View Controller
        // der aktuell angezeigte View Controller
        // Achtung! Hier gibt es drei Gleichheitszeichen!
        if  viewController === tabBarController.selectedViewController
        {
            return false
        }
        return true
     
    
    }
    
    
}





