//
//  TravelCheckItem.swift
//  CarManager
//
//  Created by Holger Hinzberg on 08.06.15.
//  Copyright (c) 2015 Holger Hinzberg. All rights reserved.
//

import Foundation

class TravelCheckItem : NSObject, NSCoding
{
    // Die Beschreibung als Zeichenkette
    var itemDescription:String
    // Wurde das Problem bereits überprüft?
    var isChecked:Bool
    // Eine Eigenschaft zur Identifizierung
    var identifier:Int
    
    override init()
    {
        self.itemDescription = ""
        self.isChecked = false
        self.identifier = 0
        super.init()
    }
    
    func encodeWithCoder(aCoder: NSCoder)
    {
        // Die Eigenschaften für eine Serialisierung umwandeln
        aCoder.encodeInt(
            Int32(self.identifier), forKey: "identifier")
        aCoder.encodeBool(
            self.isChecked, forKey: "isChecked")
        aCoder.encodeObject(
            self.itemDescription, forKey: "itemDescription")
    }
    
    required init?(coder aDecoder: NSCoder)
    {
        self.identifier = aDecoder
            .decodeIntegerForKey("identifier")
        self.isChecked = aDecoder
            .decodeBoolForKey("isChecked")
        self.itemDescription = aDecoder
            .decodeObjectForKey("itemDescription") as! String
    }
}







