//
//  TravelCheckRepository.swift
//  CarManager
//
//  Created by Holger Hinzberg on 08.06.15.
//  Copyright (c) 2015 Holger Hinzberg. All rights reserved.
//

import Foundation

class TravelCheckRepository
{
    // Ein Dictionary mit CheckItems
    private var checkItemsDictionary:[Int:TravelCheckItem]
    

    
    init()
    {
        self.checkItemsDictionary
            = [Int:TravelCheckItem]()
        
        let file = self.getFilenameWithPath()
        let fileExists = NSFileManager
            .defaultManager().fileExistsAtPath(file)
        
        if fileExists == true
        {
            print("Datei laden")
            self.load()
        }
        else
        {
            print("Dictionary erstellen")
            self.createCheckItems()
        }
    }
    
    
    
    
    
    /*
    init()
    {
        self.checkItemsDictionary
            = [Int:TravelCheckItem]()
        
        var item = TravelCheckItem()
        item.itemDescription = "Reifendruck"
        item.identifier = 109
        self.checkItemsDictionary
            .updateValue(item, forKey: item.identifier)
        
        item = TravelCheckItem()
        item.itemDescription = "Ölstand"
        item.identifier = 23
        self.checkItemsDictionary
            .updateValue(item, forKey: item.identifier)
        
        item = TravelCheckItem()
        item.itemDescription = "Warndreieck"
        item.identifier = 92
        self.checkItemsDictionary
            .updateValue(item, forKey: item.identifier)
        
        item = TravelCheckItem()
        item.itemDescription = "Verbandskasten"
        item.identifier = 5
        self.checkItemsDictionary
            .updateValue(item, forKey: item.identifier)
    }
    */
    
    // Diese Methode wird immer genau ein
    // Item zurück geben
    func getItemAtIndex(index:Int) -> TravelCheckItem
    {
        // Alle Schlüssel aus dem Dictionary holen
        //let keys = Array(self.checkItemsDictionary.keys)
        //let key = keys[index]
        // Ein Objekt passend zum Schlüssel zurückgeben
        return self.checkItemsDictionary[index]!
    }
    
    // Die Anzahl der Objekte im Array
    // als Eigenschaft der Klasse
    var itemsCount:Int
    {
        get { return self.checkItemsDictionary.count }
    }
    
    func getItemForIdentifier(identifier:Int) -> TravelCheckItem?
    {
        // Das Objekt zum passenden
        // Key zurückgeben
        return self.checkItemsDictionary[identifier]
    }
    
    func getFilenameWithPath() -> String
    {
        // Den Documents-Pfad ermitteln und ausgeben
        let fileManager = NSFileManager.defaultManager()
        let urls = fileManager.URLsForDirectory(
            .DocumentDirectory, inDomains: .UserDomainMask)
        let filePath = urls.first?.URLByAppendingPathComponent("checkItems.txt")
        return filePath!.path!
    }
    
    func save() -> Bool
    {
        // Das Dictionary unter dem angegebenen
        // Dateinamen archivieren
        let filePath = self.getFilenameWithPath()
        return NSKeyedArchiver.archiveRootObject(
            self.checkItemsDictionary, toFile: filePath)
    }
    
    func load()
    {
        let file = self.getFilenameWithPath()
        self.checkItemsDictionary
            = NSKeyedUnarchiver
            .unarchiveObjectWithFile(file) as! [Int:TravelCheckItem]
    }
    
    func createCheckItems()
    {
        var helperArray = [TravelCheckItem]()
        
        var item = TravelCheckItem()
        item.itemDescription = "Reifendruck"
        item.identifier = 109
        helperArray.append(item)
        
        item = TravelCheckItem()
        item.itemDescription = "Ölstand"
        item.identifier = 23
        helperArray.append(item)
        
        item = TravelCheckItem()
        item.itemDescription = "Warndreieck"
        item.identifier = 92
        helperArray.append(item)
        
        item = TravelCheckItem()
        item.itemDescription = "Verbandskasten"
        item.identifier = 5
        helperArray.append(item)
        
        helperArray.sortInPlace(
            { $0.itemDescription < $1.itemDescription })
        
        for helper in helperArray
        {
            print(helper.itemDescription)
        }
        
        var identifierIndex = 0
        for helper in helperArray
        {
            // Den Wert identifierIndex dem
            // TravelCheckItem zuweisen, über den
            // es später gefunden werden kann
            helper.identifier = identifierIndex
            
            self.checkItemsDictionary.updateValue(
                helper, forKey: helper.identifier)
            
            identifierIndex++
        }
    }
    
}
