//
//  TravelCheckViewController.swift
//  CarManager
//
//  Created by Holger Hinzberg on 28.05.15.
//  Copyright (c) 2015 Holger Hinzberg. All rights reserved.
//

import UIKit

class TravelCheckViewController: UIViewController
{
    private var checkRepository:TravelCheckRepository?
    // Ein bezeichnungsfelder zur Anzeige
    // der Zustandänderungen
    private var statusLabel:UILabel?
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.checkRepository = TravelCheckRepository()
        
        // Die Anzahl der TravelCheckItem ermitteln
        let count = self.checkRepository!.itemsCount
        let spacingTop:Int = 50
        
        // Das Steuerelemente erzeugen und dem View hinzufügen
        
        var i:Int = 0
        for i = 0; i < count; i++
        {
            // Ein Objekt aus der Auflistung auslesen
            let checkItem = self.checkRepository!.getItemAtIndex(i)
            
            // Ein UISwitch-Steuerelement erzeugen und dem
            // View hinzufügen
            let switchFrame
            = CGRectMake(251 , CGFloat(spacingTop + (i * 39)), 51, 31)
            let switchCtrl = UISwitch(frame: switchFrame)
            
            // Die Eigenschaft on entsprechend der
            // Eigenschaft isChecked de TravelCheckItem 
            // setzen
            switchCtrl.on = checkItem.isChecked
            
            
            // Ein Ereignis mit einer Methode verbinden
            switchCtrl.addTarget(self, action: "switchChanged:", forControlEvents: UIControlEvents.ValueChanged)
            
            // Die Eigenschaft tag zuweiesen
            switchCtrl.tag = checkItem.identifier;
            
            self.view.addSubview(switchCtrl)
            
            // Ein Bezeichnungsfeld erzeugen
            let labelFrame
            = CGRectMake(20, CGFloat(spacingTop + 5 + (i * 39)), 193, 21)
            let labelCtrl = UILabel(frame: labelFrame)
            // Die Eigenschaft text ist die itemDescription.
            labelCtrl.text = checkItem.itemDescription
            self.view.addSubview(labelCtrl)
        }
        
        // Ein Bezeichnungsfeld hinzufügen
        let distance = spacingTop + (i * 35) + 40
        let statusFrame = CGRectMake(20, CGFloat(distance), 280, 21)
        self.statusLabel = UILabel(frame: statusFrame)
        self.view.addSubview(self.statusLabel!)
        
        // Die Nachricht vom Nachrichtencenter abonnieren
        NSNotificationCenter.defaultCenter().addObserver(
            self, selector: "didEnterBackground:",
            name: "enterBackgroundNotification", object: nil)
        
   }

    func didEnterBackground(note:NSNotification)
    {
        print("Nachricht erhalten - App wird inaktiv")
        // Das Repository speichern
        let result = self.checkRepository?.save()
        if result == true
        {
            print("Archivierung erfolgreich")
        }
        else
        {
            print("Archivierung nicht erfolgreich")
        }
    }
    
    func switchChanged(sender:UISwitch)
    {
        var status:String
        
        if sender.on
        {
            status = "eingeschaltet"
        }
        else
        {
            status = "ausgeschaltet"
        }
        
        print("Der Schalter mit dem Eitikett",terminator: "")
        print(" \(sender.tag) wurde \(status).")
        
        // Das richtige Item finden
        let item = self.checkRepository?.getItemForIdentifier(sender.tag)
        
        if let item = item
        {
            // Den Zustand anzeigen
            let statusMessage = "\(item.itemDescription) \(status)"
            self.statusLabel?.text = statusMessage
            self.statusLabel?.textColor = UIColor.blackColor()
        }
        else
        {

            self.statusLabel?.text = "Objekt nicht gefunden"
            self.statusLabel?.textColor = UIColor.redColor()
        }
    }
    
    deinit
    {
        NSNotificationCenter.defaultCenter().removeObserver(self, name: "enterBackgroundNotification", object: nil)
    }
    
    
}
